#!/usr/bin/env python3
# -*- coding: utf-8 -*-
 
import sys
import os
import math
import time
import numpy as np
import matplotlib.pyplot as plt
 
sys.path.append('gridmap') 
import GridMap as gmap
import GridMapFuserReference as fuser

FLAG_PLOT = True
 
if __name__ == "__main__":

    if len(sys.argv) >= 2:
        scanfile = sys.argv[1]
    else:
        scanfile = 'test.scan'


    gridmap = gmap.GridMap(100, 100, 0.1)

    i = 0

    with open(scanfile,'r') as scanfile:
        for scanline in scanfile:
            vals = scanline.replace('\n','').split(',')
            pose = [ float(val) for val in  vals[:3]]
            d = int ( ( len(vals) - 3 ) / 2 )
            scan_x = [ float(val) for val in  vals[3:3+d] ]
            scan_y = [ float(val) for val in  vals[3+d:] ]

            i += 1
            print ('Fusing scan #%d' % i)
            fuser.fuse_laser_scan(gridmap, pose, scan_x, scan_y)

            #plot the gridmap
            if FLAG_PLOT:
                gmap.plot_map(gridmap)
                plt.pause(.000001)

    if FLAG_PLOT:
        plt.show()

    
